#!/usr/bin/env python
import os
import time
from sys import argv
from urlparse import urlparse
 
"""
def xdghome(key, default):
	'''Attempts to use the environ XDG_*_HOME paths if they exist otherwise
	use $HOME and the default path.'''

	xdgkey = "XDG_%s_HOME" % key
	if xdgkey in os.environ.keys() and os.environ[xdgkey]:
		return os.environ[xdgkey]

	return os.path.join(os.environ['HOME'], default)
"""

# Blockfile location.
BLOCKFILE = os.path.dirname(argv[0]) + "/adblock"

JAVASCRIPT = '''
(function() {
	var toblock = '%s';
	var items = document.querySelectorAll(toblock);
//	alert(items.length + ' blocked');
	for (var i=0;i<items.length;i++) {
		try {
			items[i].parentNode.removeChild(items[i]);
		} catch (e) {
			continue;
		}
	}
})();
'''
 
def get_domain(url):
	'''Return domain segment of url.'''

	if not url.startswith('http'):
		url = "http://%s" % url

	loc = urlparse(url).netloc
	if loc.startswith('www.'):
		loc = loc[4:]

	return loc
 
 
def adblock(url, winid):
	fh = open(BLOCKFILE, 'r')
	lines = [line.strip() for line in fh]
	fh.close()

	url = get_domain(url)
	rules = []
	capture = False
	for l in lines:
		if not l:
			capture = False
		elif capture:
			l = l.strip()
			l = l.replace("'", "\\'")
			rules.append(l.strip())
		else:
			if get_domain(l) == url or l == "global":
				capture = True

	rulestr = ','.join(rules)
	js = "%s\n" % (JAVASCRIPT % rulestr)

	filename = os.tempnam("/tmp", "surf_")
	fh = open(filename, "w")
	fh.write(js)
	fh.close()

	prop = "_SURF_SCRIPT"
	cmd = "xprop -id %s -f %s 8s -set %s \"%s\"" % (winid, prop, prop, filename)
	os.system(cmd)
	# Give some time to execute javascripts.
	time.sleep(2)
	# Remove script / cleanup.
	os.unlink(filename)

if __name__ == '__main__':
	adblock(get_domain(argv[2]), argv[1])
